"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class AcmgEvidence(ProtocolElement):
    """
    Represents a single ACMG criterion (PVS1, BA1, PM1... etc) used in the
    classification of a variant, along with the strength applied at
    and evidence supporting it.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "activationStrength",
        "category",
        "modifier",
        "type",
        "weight",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import reports as reports_7_0_0

        return {
            "comments": reports_7_0_0.UserComment,
            "flaggedPublications": reports_7_0_0.Publication,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import reports as reports_7_0_0

        return {
            "activationStrength": reports_7_0_0.ActivationStrength,
            "category": reports_7_0_0.AcmgEvidenceCategory,
            "type": reports_7_0_0.AcmgEvidenceType,
            "weight": reports_7_0_0.AcmgEvidenceWeight,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import reports as reports_7_0_0

        return {
            "org.gel.models.report.avro.ActivationStrength": reports_7_0_0.ActivationStrength,
            "org.gel.models.report.avro.AcmgEvidenceCategory": reports_7_0_0.AcmgEvidenceCategory,
            "org.gel.models.report.avro.UserComment": reports_7_0_0.UserComment,
            "org.gel.models.report.avro.Publication": reports_7_0_0.Publication,
            "org.gel.models.report.avro.AcmgEvidenceType": reports_7_0_0.AcmgEvidenceType,
            "org.gel.models.report.avro.AcmgEvidenceWeight": reports_7_0_0.AcmgEvidenceWeight,
            "org.gel.models.report.avro.AcmgEvidence": reports_7_0_0.AcmgEvidence,
        }

    __slots__ = [
        "activationStrength",
        "category",
        "modifier",
        "type",
        "weight",
        "comments",
        "description",
        "flaggedPublications",
    ]

    def __init__(
        self,
        activationStrength,
        category,
        modifier,
        type,
        weight,
        comments=None,
        description=None,
        flaggedPublications=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_7_0_0.AcmgEvidence model.

        :param activationStrength:
            The strength this criterion has been used at in this interpretation.
            e.g. if PM2 was only used at "supporting" rather than
            "moderate", the activation strength would be "supporting"
        :type activationStrength: ActivationStrength
        :param category:
            Evidence category as defined in ACMG guidelines
        :type category: AcmgEvidenceCategory
        :param modifier:
            The number suffix at the end of the ACMG criteria code e.g PM2 would
            be 2
        :type modifier: int
        :param type:
            Evidence type: benign or pathogenic
        :type type: AcmgEvidenceType
        :param weight:
            Default strength for criterion as defined in Table 3 of ACMG
            guidelines (Richards et al 2015). e.g. PM2 would be
            "moderate"
        :type weight: AcmgEvidenceWeight
        :param comments:
            User comments attached to this ACMG criteria in this case
        :type comments: None | list[UserComment]
        :param description:
            The description of the evidence as described in ACMG guidelines e.g.
            for PM2 the description would be "Absent from controls (or
            at extremely low frequency if recessive) in Exome
            Sequencing Project, 1000 Genomes Project, or Exome
            Aggregation Consortium"
        :type description: None | str
        :param flaggedPublications:
            Publications flagged by the user as relevant to this ACMG evidence
        :type flaggedPublications: None | list[Publication]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "7.0.0"
